    Info<< "Reading mechanical properties\n" << endl;

    IOdictionary mechanicalProperties
    (
        IOobject
        (
            "mechanicalProperties",
            runTime.constant(),
            mesh,
            IOobject::MUST_READ,
            IOobject::NO_WRITE
        )
    );

    dimensionedScalar E(mechanicalProperties.lookup("E"));
    dimensionedScalar nu(mechanicalProperties.lookup("nu"));
    dimensionedScalar ky(mechanicalProperties.lookup("ky"));
    dimensionedScalar  k(mechanicalProperties.lookup("k"));
    dimensionedScalar  gamma(mechanicalProperties.lookup("gamma"));
    dimensionedScalar  n(mechanicalProperties.lookup("n"));
    dimensionedScalar  Kprime(mechanicalProperties.lookup("Kprime"));

    dimensionedScalar Dp1 = k/gamma*(Kprime/n);
    dimensionedScalar Dp2= Kprime/n;
 
    Info<< "Calculating Lame's coefficients\n" << endl;

    dimensionedScalar mu = E/(2.0*(1.0 + nu));
    dimensionedScalar lambda = nu*E/((1.0 + nu)*(1.0 - 2.0*nu));

    Switch planeStress(mechanicalProperties.lookup("planeStress"));

    if (planeStress)
    {
        Info<< "Plane Stress\n" << endl;

        //- change lambda for plane stress
        lambda = nu*E/((1.0 + nu)*(1.0 - nu));
    }
    else
    {
        Info<< "Plane Strain\n" << endl;
    }
    Info<< "mu = " << mu.value() << " Pa/rho\n";
    Info<< "lambda = " << lambda.value() << " Pa/rho\n";
